100 REMark MaQnify (Screen Magnifier) by Dilwyn Jones 2014
110 REMark Freeware
120 :
130 REMark Core_bas - set of common routines for DJ programs
140 REMark needs DJToolkit, Display_cde v2
150 REMark needs following menus: yorn_men, errormen_men
160 REMark                     blankmen_men, nowman2_men
170 :
180 REMark amend directory names below as appropriate when recompiling
190 REMark $$asmb=win1_bootup_djtoolkit_bin,0,12
200 REMark $$asmb=win1_bootup_display_cde,0,10
210 REMark $$asmb=win1_bootup_qlib_ext,0,12
220 REMark $$asmb=win1_magnifier_ptrmen_cde,4,82
230 REMark $$asmb=win1_magnifier_chanid_cde,0,10
240 REMark $$asmb=win1_magnifier_qbase_cde,0,10
250 REMark $$asmb=win1_magnifier_maqnify_cfg,0,12
260 :
270 DEF_INTEGER x,y
280 :
290 REMark basic config block
300 sp%          = C_CODE(1) : REMark System Palette 0
310 def_time%    = C_WORD(1) : REMark default time between pointer reads
320 version$     = C_VERS$   : REMark program version number
330 scale%       = C_BYTE(1) : REMark magnify factor - x2 or x4
340 xsize%       = C_WORD(2) : REMark menu width at startup (min 392)
350 ysize%       = C_WORD(3) : REMark menu height at startup (min 94)
360 originx%     = C_WORD(4) : REMark menu startup x origin
370 originy%     = C_WORD(5) : REMark menu startup y origin
380 fulldisplay% = C_CODE(2) : REMark 0=minimal display, 1=icons bar at top
390 textmode%    = C_CODE(3) : REMark 0=pointer, 1=text
400 :
410 IF Q_MYJOB <> 0 THEN
420   OPEN #0,'con' : OPEN #1,'con' : OPEN #2,'con'
430   md$ = '' : mx$ = ''
440 ELSE
450   md$ = 'win1_magnifier_' : mx$ = '_men'
460 END IF
470 :
480 Is_Wman_Too_Old
490 :
500 REMark set initial system palette number
510 IF CHECK('SP_JOBPAL') THEN SP_JOBPAL -1,sp%
520 :
530 REMark set up opening menu
540 IF xsize% = 0 THEN xsize% = FLIM_W(#0)
550 IF ysize% = 0 THEN ysize% = FLIM_H(#0)
560 IF fulldisplay% = 1 THEN
570   REMark menu with icons
580   MSETUP #0,md$&'magnify'&mx$,originx%,originy%,xsize%,ysize%
590   MINOB #0\2,1,'x'&scale%
600   Show_Follow_Mode
610   MDRAW #0
620   Heading 'MaQnifier'
630 ELSE
640   REMark minimal (no icons) display
650   MDRAW #0,md$&'magnify0'&mx$,originx%,originy%,xsize%,ysize%
660 END IF
670 :
680 REMark bit masks array, used to speed up calculation in mode 4 magnify
690 DIM b%(7)
700 FOR a = 0 TO 7 : b%(a) = 2^(7-a)
710 :
720 DIM pr%(15)           : REMark pointer return values
730 old_sd_base      = -1 : REMark previous queue origin
740 old_sd_xpos%     = -1 : REMark previous x co-ordinate of text cursor
750 old_sd_ypos%     = -1 : REMark previous y co-ordinate of text cursor
760 old_sd_curf%     = -1 : REMark cursor flag state
770 sv_keyq          = 0  : REMark when in follow text cursor mode
780 previous_sv_keyq = 0  : REMark track changes in keyboard queue pointer
790 :
800 REMark programis to run at low priority unless redrawing magnified screen
810 QP -1,2 : REMark low priority unless redrawing magnified screen
820 :
830 REPeat program
840   event% = 255 : time% = def_time%
850   num = MCALLT(#0,event%,time%) : PVAL #0,pr%
860   :
870   REMark check for key codes for controls in minimal no-icon window mode
880   REMark convert to equivalent loose item number or direct action
890   key = pr%(6) : REMark code of key pressed
900   SELect ON key
910     =27         : num = -11  : REMark esc
920     =245        : num = -1   : NEXT program : REMark CF4=move
930     =241        : num = -2   : REMark CF3=Resize
940     =237        : num = -5   : REMark CF2=refresh
950     =127        : num = -10  : REMark =Copyright notice
960     =43         : num = -9   : REMark +=increase scale
970     =45         : num = -8   : REMark -=decrease scale
980     =70,102     : num = -7   : REMark F=focus on pointer/text cursor
990     =80,112     : REMark P=pointer focus mode
1000                   IF fulldisplay% = 0 THEN
1010                     textmode% = 0
1020                     Show_Follow_Mode
1030                     stat% = MSTAT%(#0,-7 TO 0) : REMark force redraw of this item
1040                     NEXT program
1050                   END IF
1060     =67,99      : REMark C=cursor focus mode
1070                   IF fulldisplay% = 0 THEN
1080                     textmode% = 1
1090                     Show_Follow_Mode
1100                     stat% = MSTAT%(#0,-7 TO 0) : REMark force redraw of this item
1110                     NEXT program
1120                   END IF
1130     =86,118,236,240 : num = -6 : REMark F2/F3/V=view mode full/minimal
1140     =49 TO 56   : scale% = key-48 : REMark 1-8=scale 1 to 8
1150                   IF fulldisplay% = 1 THEN MINOB #0,2,1,'x'&scale%
1160                   NEXT program
1170   END SELect
1180   sd_curf% = 0 : REMark assume channel has no active cursor
1190   IF textmode% = 1 THEN
1200     REMark magnify text around flashing cursor
1210     QP -1,32 : Magnify_Text : QP -1,32
1220   END IF
1230   IF textmode% = 0 OR (textmode% = 1 AND sd_curf% = 0) THEN
1240     REMark magnify around pointer if no keyboard queue available
1250     REMark or in follow pointer mode
1260     Heading 'MaQnifier'
1270     IF pr%(7) && 8 THEN
1280       REMark pointer moved - is it out of window?
1290       IF pr%(7) && 16 THEN
1300         REMark pointer out of window (do not redraw while pointer is in window)
1310         QP -1,32 : Set_Magnify_Area : Magnify_Area : QP -1,2
1320       END IF
1330     END IF
1340   END IF
1350   IF num = -1280 THEN
1360     IF (event% && 2)  =  2 THEN num = -10 : REMark convert to Esc code
1370     IF (event% && 8)  =  8 THEN num = -1  : REMark convert to Move code
1380     IF (event% && 16) = 16 THEN num = -2  : REMark convert to Resize code
1390     IF (event% && 32) = 32 THEN num = -3  : REMark convert to sleep code
1400     IF (event% && 64) = 64 THEN num = -5  : REMark convert to Refresh code
1410   END IF
1420   SELect ON num
1430     =-1 : WMOV #0,-1 : REMark move
1440     =-2 : REMark resize with origin lock
1450       PVAL #0,pr% : WSIZE #0,xv%,yv% : MCLEAR #0
1460       REMark top left resize icon
1470       xsize% = pr%(8) + xv% : ysize% = pr%(9) - yv%
1480       IF fulldisplay% = 1 THEN
1490         MSETUP #0,md$&'magnify'&mx$,pr%(10),pr%(11)+yv%,xsize%,ysize%
1500         MINOB #0\2,1,'x'&scale%
1510         Show_Follow_Mode
1520         MDRAW #0
1530       ELSE
1540         MDRAW #0,md$&'magnify0'&mx$,pr%(10),pr%(11)+yv%,xsize%,ysize%
1550       END IF
1560     =-3 : REMark sleep, handled internally
1570     =-4 : REMark System Palette number
1580       sp% = sp%+1 : IF sp% > 3 THEN sp% = 0
1590       IF CHECK('SP_JOBPAL') THEN SP_JOBPAL -1,sp%
1600       stat% = MSTAT%(#0,num TO 0) : MDRAW #0 : REMark redraw
1610     =-5 : MDRAW #0 : REMark refresh
1620     =-7 : REMark C/F = pointer or text focus
1630       textmode% = NOT textmode% : Show_Follow_Mode
1640     =-8 : REMark - = next scale down
1650       scale% = scale% - 1 : IF scale% < 2 THEN scale% = 8
1660       MINOB #0,2,1,'x'&scale%
1670     =-9 : REMark X = scale factor
1680       scale% = scale%+1 : IF scale% > 8 THEN scale% = 2
1690       MINOB #0,2,1,'x'&scale%
1700       REMark IF fulldisplay% = 1 THEN MITEM #0,-8,1,'x'&scale%,'x'
1710     =-10 : REMark  = copyright menu
1720       MWINDOW #0,1 : CLS #0 : OVER #0,0 : WM_INK #0,HEX('0218')
1730       CSIZE #0,2,0 : PRINT #0,'MAQNIFIER SCREEN MAGNIFIER v';version$
1740       PRINT #0,\'Copyright  2014 Dilwyn Jones'
1750       PRINT #0,'This program is freeware.'
1760       PRINT #0,\'Press any key to continue > ';
1770       Q_CURSON #0 : PAUSE : Q_CURSOFF #0 : CLS #0 : CSIZE #0,0,0
1780     =-11 : REMark ESC - Quit?
1790       IF YesOrNo('Quit - are you sure ?') = 1 THEN EXIT program
1800     =-6,1 : REMark app window 1 or V=window icon - toggle display view type
1810       IF (num = 1 AND (MKEY%(#0) = 1 OR MKEY%(#0) = 2)) OR num = -6 THEN
1820         ox% = FLIM_X(#1) : oy% = FLIM_Y(#1)
1830         fulldisplay% = NOT fulldisplay% : MCLEAR #0
1840         IF fulldisplay% = 1 THEN
1850           REMark use window with icons
1860           xsize% = pr%(8) : ysize% = pr%(9) : REMark no resize
1870           MSETUP #0,md$&'magnify'&mx$,ox%,oy%,xsize%,ysize%
1880           MINOB #0\2,1,'x'&scale%
1890           Show_Follow_Mode
1900           MDRAW #0
1910         ELSE
1920           REMark use minimal magnifier window without icons
1930           MDRAW #0,md$&'magnify0'&mx$,ox%,oy%,xsize%,ysize%
1940         END IF
1950       END IF
1960     =-1280 : REMark event or timeout
1970       REMark Show_Message 'Event return='&event%&' '&time%
1980   END SELect
1990   IF num < 0 AND num > -1280 AND fulldisplay% = 1 THEN stat% = MSTAT%(#0,num TO 0)
2000 END REPeat program
2010 :
2020 MCLEAR #0
2030 :
2040 IF Q_MYJOB = 0 THEN
2050   REMark reset BASIC windows (menus may leave them random)
2060   OVER #2,0 : PAPER #2,7 : INK #2,2
2070   OVER #1,0 : PAPER #1,2 : INK #1,7
2080   OVER #0,0 : PAPER #0,0 : INK #0,7
2090 END IF
2100 :
2110 STOP
2120 :
2130 DEFine PROCedure Show_Follow_Mode
2140   LOCal stat%
2150   REMark flick sprites used to denote if currently pointer or cursor following
2160   IF fulldisplay% = 1 THEN
2170     IF textmode% = 0 THEN MITEM #0,-7,-2,SPRA(textmode%+1),'c' : ELSE MITEM #0,-7,-2,SPRA(textmode%+1),'p' : END IF
2180   END IF
2190 END DEFine Show_Follow_Mode
2200 :
2210 DEFine PROCedure Set_Magnify_Area
2220   IF fulldisplay% = 1 THEN
2230     wwide% = FLIM_W(#1)-8-4  : REMark window width
2240     whigh% = FLIM_H(#1)-30-2 : REMark window height
2250   ELSE
2260     wwide% = FLIM_W(#1)-4-4  : REMark window width
2270     whigh% = FLIM_H(#1)-2-2  : REMark window height
2280   END IF
2290   sd_xpos% = pr%(14) : REMark pointer absolute x position
2300   sd_ypos% = pr%(15) : REMark pointer absolute y position
2310   ox% = sd_xpos% - ((wwide% DIV 2) DIV scale%) + 1
2320   IF ox% < 0 THEN ox% = 0
2330   ex% = ox% + (wwide% DIV scale%) - 1 : REMark end x co-ordinate
2340   IF ex% >= SCR_XLIM THEN ex% = SCR_XLIM-1
2350   oy% = sd_ypos% - ((whigh% DIV 2) DIV scale%) + 1
2360   IF oy% < 0 THEN oy% = 0
2370   ey% = oy% + (whigh% DIV scale%) - 1 : REMark end y co-ordinate
2380   IF ey% >= SCR_YLIM THEN ey% = SCR_YLIM(#0)-1
2390   :
2400   Magnify_Area
2410 END DEFine Set_Magnify_Area
2420 :
2430 DEFine PROCedure Magnify_Text
2440   REMark queue is just after the definition block for this window channel
2450   REMark SV_KEYQ $4C 76 long = pointer to a keyboard queue
2460   REMark locate base of screen driver data block definition below queue
2470   previous_sv_keyq = sv_keyq
2480   sv_keyq = PEEK_L(VER$(-2)+76) : REMark pointer to a keyboard queue
2490   IF sv_keyq = 0 THEN
2500     REMark no active queue at the moment
2510     RETurn
2520   END IF
2530   IF sv_keyq <> previous_sv_keyq THEN
2540     REMark show new job name
2550     Heading Q_NAME$
2560   END IF
2570   :
2580   REMark subtract difference between app win 1 size and outline and allow for border
2590   IF fulldisplay% = 1 THEN
2600     wwide% = FLIM_W(#1)-8-4  : REMark window width
2610     whigh% = FLIM_H(#1)-30-2 : REMark window height
2620   ELSE
2630     wwide% = FLIM_W(#1)-4 : REMark window width
2640     whigh% = FLIM_H(#1)-2 : REMark window height
2650   END IF
2660   REMark at this scaling and window size, how many pixels from screen can we fit in?
2670   scaledw% = wwide% DIV scale%
2680   scaledh% = whigh% DIV scale%
2690   :
2700   REMark queue is just after the definition block for this window channel
2710   sd_base = sv_keyq-104 : REMark base of channel block for this queue
2720   :
2730   REMark parts used by screen driver data block definition (from QL Technical Guide):
2740   REMark SD_XMIN  $18 (24) word - window top left x-origin
2750   REMark SD_YMIN  $1A (26) word - window top left y-origin
2760   REMark SD_XSIZE $1C (28) word - window width (pixels)
2770   REMark SD_YSIZE $1E (30) word - window height (pixels)
2780   REMark SD_BORWD $20 (32) word - border width
2790   REMark SD_XPOS  $22 (34) word - cursor x position
2800   REMark SD_YPOS  $24 (36) word - cursor y position
2810   REMark SD_XINC  $26 (38) word - cursor increment in pixels across
2820   REMark SD_YINC  $28 (40) word - cursor increment in pixels down
2830   REMark SD_CURF  $43 (67) byte - cursor flag (0=suppressed,1=flashing on,255=flashing off)
2840   sd_borwd  = PEEK_W(sd_base+32) : REMark border width
2850   sd_xmin%  = PEEK_W(sd_base+24)-(2*sd_borwd) : REMark window x-origin
2860   sd_ymin%  = PEEK_W(sd_base+26)-sd_borwd     : REMark window y-origin
2870   sd_xsize% = PEEK_W(sd_base+28)+(4*sd_borwd) : REMark window width in pixels
2880   sd_ysize% = PEEK_W(sd_base+30)+(2*sd_borwd) : REMark window height in pixels
2890   :
2900   REMark where's the cursor?
2910   sd_xpos% = sd_xmin% + PEEK_W(sd_base+34) : REMark cursor x-coord absolute
2920   sd_ypos% = sd_ymin% + PEEK_W(sd_base+36) : REMark cursor y-coord absolute
2930   :
2940   REMark if no flashing cursor do not attempt to redraw
2950   sd_curf% = PEEK(sd_base+67)                 : REMark cursor flag
2960   IF sd_curf% = 0 THEN
2970     REMark sv_keyq = 0
2980     RETurn : REMark err...oops..no cursor!
2990   END IF
3000   :
3010   REMark don't need to redraw if nothing has changed
3020   IF sd_base = old_sd_base AND sd_xpos% = old_sd_xpos% AND sd_ypos% = old_sd_ypos% THEN
3030     REMark same queue, same cursor position
3040     REMark so, unless cursor at edge of window, don't redraw - edges
3050     REMark allow redrawing to occur when scrolling up/down at screen edges
3060     IF PEEK_W(sd_base+36) >= PEEK_W(sd_base+40) AND PEEK_W(sd_base+36) < (PEEK_W(sd_base+30)-PEEK_W(sd_base+40)) THEN RETurn
3070     REMark ditto for panning left/right
3080     IF PEEK_W(sd_base+34) >= PEEK_W(sd_base+38) AND PEEK_W(sd_base+34) < (PEEK_W(sd_base+28)-PEEK_W(sd_base+38)) THEN RETurn
3090   END IF
3100   :
3110   REMark work out visible position - start by assuming cursor position is centre
3120   ox% = sd_xpos% - (scaledw% DIV 2) + 1
3130   IF ox% < 0 THEN ox% = 0
3140   IF ox% < sd_xmin% THEN ox% = sd_xmin%
3150   ex% = ox% + scaledw% - 1 : REMark end x co-ordinate
3160   IF ex% >= FLIM_W(#0) THEN ex% = FLIM_W(#0)-1 : REMark off-screen?
3170   IF ex% >= (sd_xmin%+sd_xsize%) THEN ex% = sd_xmin%+sd_xsize%-1 : REMark out of window?
3180   REMark are we using full window (where possible)?
3190   ox% = ex% - scaledw% + 1
3200   IF ox < 0 THEN ox% = 0
3210   IF ox% < sd_xmin% THEN ox% = sd_xmin%
3220   :
3230   oy% = sd_ypos% - (scaledh% DIV 2) + 1
3240   IF oy% < 0 THEN oy% = 0
3250   IF oy% < sd_ymin% THEN oy% = sd_ymin%
3260   ey% = oy% + (whigh% DIV scale%) - 1 : REMark end y co-ordinate
3270   IF ey% >= FLIM_H(#0) THEN ey% = FLIM_H(#0)-1
3280   IF ey% >= (sd_ymin%+sd_ysize%) THEN ey% = sd_ymin%+sd_ysize%-1
3290   REMark are we magnifying as much of the window as possible?
3300   oy% = ey%-scaledh%+1
3310   IF oy% < 0 THEN oy% = 0
3320   IF oy% < sd_ymin% THEN oy% = sd_ymin%
3330   Magnify_Area
3340   :
3350   REMark re-enable cursor in focused program here after magnifying
3360   :
3370   IF scale%*(ex%-ox%+1) < wwide% THEN
3380     REMark clear any unused part on the right of the magnifier window
3390     WM_BLOCK #0,wwide%-(scale%*(ex%-ox%+1)),whigh%,scale%*(ex%-ox%+1),0,HEX('0217')
3400   END IF
3410   :
3420   IF scale%*(ey%-oy%+1) < whigh% THEN
3430     REMark clear any unused part bottom of the magnifier window
3440     WM_BLOCK #0,wwide%,whigh%-(scale%*(ey%-oy%+1)),0,scale%*(ey%-oy%+1),HEX('0217')
3450   END IF
3460   COLOUR_QL : REMark restore colour normality between redraws
3470   :
3480   REMark remember what we got up to this time
3490   old_sd_base = sd_base : old_sd_xpos% = sd_xpos% : old_sd_ypos% = sd_ypos% : old_sd_curf% = sd_curf%
3500 END DEFine Magnify_Text
3510 :
3520 REMark $$off
3530 :
3540 DEFine PROCedure Sa
3550   QSAVE 'win1_magnifier_maqnifier' : SAVE  'win1_magnifier_maqnifier_bas'
3560 END DEFine Sa
3570 :
3580 DEFine PROCedure XTV
3590   OUTLN #0,FLIM_W(#0),FLIM_H(#0),0,0
3600   WINDOW FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #2,FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #0,FLIM_W(#0),52,0,FLIM_H(#0)-52
3610   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
3620   CLS : CLS #2 : CLS #0
3630 END DEFine XTV
3640 :
3650 DEFine PROCedure XTV2
3660   OUTLN #0,FLIM_W(#0)/2,FLIM_H(#0),0,0
3670   WINDOW FLIM_W(#0)/2,FLIM_H(#0)-52,0,0 : WINDOW #2,FLIM_W(#0)/2,FLIM_H(#0)-52,0,0 : WINDOW #0,FLIM_W(#0)/2,52,0,FLIM_H(#0)-52
3680   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
3690   CLS : CLS #2 : CLS #0
3700 END DEFine XTV2
3710 :
3720 DEFine PROCedure Oops
3730   REMark this procedure just resets BASIC windows, OVER etc while testing
3740   MCLEAR #2 : PAPER #2,7 : INK #2,2 : OVER #2,0
3750   MCLEAR #1 : PAPER #1,2 : INK #1,7 : OVER #1,0
3760   MCLEAR #0 : PAPER #0,0 : INK #0,7 : OVER #0,0 : CLOSE : CLAMP
3770 END DEFine Oops
3780 :
3790 REMark $$on
3800 :
3810 DEFine FuNction YesOrNo (message$)
3820   LOCal a,ch%,num1
3830   ch% = FOPEN('con')
3840   IF ch% < 0 THEN RETurn ch%
3850   MSETUP #ch%,md$&'yorn'&mx$ : MINOB #ch%\1,1,message$
3860   MDRAW #ch% : num1 = MCALL(#ch%) : REMark redraw
3870   SELect ON num1
3880     =-1 : REMark move, handled internally
3890     =-2 : a =-1 : REMark ESC
3900     =-3 : a = 1 : REMark Yes
3910     =-4 : a = 0 : REMark No
3920     =REMAINDER : a = -1 : REMark Eh???
3930   END SELect
3940   MCLEAR #ch% : CLOSE #ch% : RETurn a
3950 END DEFine YesOrNo
3960 :
3970 DEFine FuNction Q_Err$ (er)
3980   LOCal e
3990   e = er
4000   SELect ON e
4010     =0    : RETurn ""
4020     =-1   : RETurn "not complete"
4030     =-2   : RETurn "invalid job"
4040     =-3   : RETurn "out of memory"
4050     =-4   : RETurn "out of range"
4060     =-5   : RETurn "buffer overflow"
4070     =-6   : RETurn "channel not open"
4080     =-7   : RETurn "not found"
4090     =-8   : RETurn "already exists"
4100     =-9   : RETurn "in use"
4110     =-10  : RETurn "end of file"
4120     =-11  : RETurn "drive full"
4130     =-12  : RETurn "bad name"
4140     =-13  : RETurn "transmission error"
4150     =-14  : RETurn "format failed"
4160     =-15  : RETurn "bad parameter"
4170     =-16  : RETurn "file error"
4180     =-17  : RETurn "error in expression"
4190     =-18  : RETurn "arithmetic overflow"
4200     =-19  : RETurn "not implemented"
4210     =-20  : RETurn "read only"
4220     =-21  : RETurn "bad line"
4230     REMark following are SMSQ/E specific
4240     =-129 : RETurn "syntax error in expression"
4250     =-130 : RETurn "missing left parenthesis"
4260     =-131 : RETurn "missing right parenthesis"
4270     =-132 : RETurn "error in line number"
4280     =-133 : RETurn "bad string: missing delimiter"
4290     =-134 : RETurn "incorrect procedure or function definition"
4300     =-135 : RETurn "procedure or function definition not allowed here"
4310     =-136 : RETurn "DEFines may not be within other clauses"
4320     =-137 : RETurn "misplaced END DEFine"
4330     =-138 : RETurn "misplaced LOCal"
4340     =-139 : RETurn "RETurn not in procedure or function"
4350     =-140 : RETurn "WHEN clauses may not be nested"
4360     =-141 : RETurn "misplaced END WHEN"
4370     =-142 : RETurn "misplaced ELSE"
4380     =-143 : RETurn "misplaced END IF"
4390     =-144 : RETurn "program structures nested too deeply, my brain aches"
4400     =-145 : RETurn "incomplete IF clause"
4410     =-146 : RETurn "incomplete SELect clause"
4420     =-147 : RETurn "incomplete DEFine"
4430     =-148 : RETurn "incomplete WHEN clause"
4440     =-149 : RETurn "unacceptable loop variable"
4450     =-150 : RETurn "unable to find an open loop"
4460     =-151 : RETurn "undefined loop control variable"
4470     =-152 : RETurn "incorrectly structured SELect clause"
4480     =-153 : RETurn "misplaced END SELect"
4490     =-154 : RETurn "DATA in command line has no meaning"
4500     =-155 : RETurn "unacceptable parameters for READ"
4510     =-156 : RETurn "SBASIC cannot perform READs within DATA expressions"
4520     =-157 : RETurn "end of DATA"
4530     =-158 : RETurn "unknown procedure"
4540     =-159 : RETurn "unknown function or array"
4550     =-160 : RETurn "only arrays may be dimensioned"
4560     =-161 : RETurn "procedure and function parameters may not be dimensioned"
4570     =-162 : RETurn "SBASIC cannot put up with negative dimensions"
4580     =-163 : RETurn "dimensional overflow - you cannot be serious!"
4590     =-164 : RETurn "error in index list"
4600     =-165 : RETurn "too many indexes"
4610     =-166 : RETurn "cannot assign to sub-array"
4620     =-167 : RETurn "unacceptable array index list"
4630     =-168 : RETurn "array index out of range"
4640     =-169 : RETurn "only arrays or strings may be indexed"
4650     =-170 : RETurn "assignment can only be to a variable or array element"
4660     =-171 : RETurn "MISTake in program"
4670     =-172 : RETurn "during when processing"
4680     =-173 : RETurn "PROC/FN cleared"
4690     =-174 : RETurn "At line "
4700     =-175 : RETurn "fatal error in SBASIC interpreter"
4710     REMark following are program specific
4720     =-984 : RETurn "FileInfo II not available"
4730     =REMAINDER : RETurn "error "&e
4740   END SELect
4750 END DEFine Q_Err$
4760 :
4770 DEFine PROCedure An_Error (error_number)
4780   LOCal ch%,num
4790   ch% = FOPEN('con')
4800   IF ch% < 0 THEN
4810     IF sound_on% THEN BEEP 5000,50
4820     PRINT #0,'Fatal error in error handler'
4830     PRINT #0,'CON channel OPEN failed.'\Q_Err$(ch%)
4840     INPUT #0,'Press ENTER ';z$ : STOP
4850   END IF
4860   MDRAW #ch%,md$&'errormen'&mx$
4870   IF sound_on% THEN BEEP 5000,50
4880   MWINDOW #ch%,2!\0 : WM_INK #ch%,HEX('0210') : OVER #ch%,0
4890   PRINT #ch%,'An error has occurred:'
4900   PRINT #ch%,Q_Err$(error_number)
4910   PRINT #ch%,'Click on [OK] to continue.'
4920   num = MCALL(#ch%) : MCLEAR #ch% : CLOSE #ch%
4930 END DEFine An_Error
4940 :
4950 DEFine PROCedure Show_Message (what$)
4960   LOCal ch%,z$
4970   ch% = FOPEN('con') : MDRAW #ch%,md$&'blankmen'&mx$
4980   PRINT #ch%,what$ : INPUT #ch%,'Press ENTER > ';z$
4990   MCLEAR #ch% : CLOSE #ch%
5000 END DEFine Show_Message
5010 :
5020 DEFine PROCedure Is_Wman_Too_Old
5030   LOCal loop,num
5040   IF WMAVER$(#0) < '2.00' THEN
5050     MDRAW #0,md$&'nowman2'&mx$
5060     REPeat loop
5070       num = MCALL(#0)
5080       SELect ON num = -1 : EXIT loop
5090     END REPeat loop
5100     MCLEAR #0 : STOP
5110   END IF
5120 END DEFine Is_Wman_Too_Old
5130 :
5140 REMark   Q_NAME$   By Michael Bulford, 25 November 2014
5150 REMark             Thank you, Michael!
5160 :
5170 REMark RETurns the name of the job owning the keyboard queue
5180 REMark needs the CHAN_ID function supplied
5190 :
5200 DEFine FuNction Q_NAME$
5210   LOCal id, num, sv_chbas, adr, window_offset, base, adr2, tag
5220   REMark following only works interpreted
5230   REMark num  = PEEK_W(\\PEEK_L(\\48)+0*40) : REMark find channel id
5240   REMark tag  = PEEK_W(\\PEEK_L(\\48)+2)    : REMark channel tag (not needed here)
5250   id = CHAN_ID(#0)             : REMark find channel ID of #0
5260   num = id-INT(id/65536)*65536 : REMark channel ID number
5270   tag = INT(id/65536)          : REMark channel tag (not used here)
5280   sv_chbas = PEEK_L(VER$(-2)+120) : REMark base of channel table ($78)
5290   adr = sv_chbas + 4*num : REMark locate channel details
5300   window_offset = CH_BASE(#0) - PEEK_L(adr)
5310   base = PEEK_L(VER$(-2)+76)-104 : REMark base of def block below queue
5320   adr2 = base - window_offset    : REMark locate num and ID of task
5330   IF INT(adr2/2)*2 <> adr2 : RETurn "" : REMark must be even
5340   RETurn JOB_NAME$(PEEK_W(adr2+10),PEEK_W(adr2+8)) : REMark supply job num,tag
5350 END DEFine Q_NAME$
5360 :
5370 DEFine FuNction JOB_NAME$(num,tag)
5380   LOCal sv_chbas, jb_ptr, jb_start
5390   IF  num = 0 THEN
5400     IF CHECK('SBASIC') THEN
5410       RETurn "SBASIC"
5420     ELSE
5430       RETurn "SuperBASIC"
5440     END IF
5450   ELSE
5460     sv_chbas = PEEK_L(VER$(-2)+104)
5470     jb_ptr = sv_chbas+(num*4)
5480     REMark Is this job number in use ?
5490     IF PEEK(jb_ptr) <> 255 THEN
5500       jb_start = PEEK_L(jb_ptr)
5510       REMark Is the tag correct ?
5520       IF tag = PEEK_W(jb_start+16) THEN
5530         REMark Is that an Ident Word (19195 = $4AFB) ?
5540         IF PEEK_W(jb_start+110) = 19195 THEN
5550           RETurn PEEK$(jb_start+114,PEEK_W(jb_start+112))
5560         ELSE
5570           RETurn "No Name"
5580         END IF
5590       END IF
5600     END IF
5610     RETurn "*Not Valid*"
5620   END IF
5630 END DEFine JOB_NAME$
5640 :
5650 REMark $$off
5660 REMark IDs for testing purposes only
5670 DEFine PROCedure IDs
5680   base=PEEK_L(\\$30)
5690   FOR chan = 0 TO 2
5700     PRINT PEEK_L(\\PEEK_L(\\48)+40*chan)!PEEK_W(\\PEEK_L(\\48)+40*chan)!PEEK_W(\\PEEK_L(\\48)+40*chan)
5710     ad = base+(40*chan)
5720     PRINT PEEK_L(\\ad),PEEK_W(\\ad),PEEK_W(\\ad+2)
5730   END FOR chan
5740 END DEFine IDs
5750 REMark $$on
5760 :
5770 DEFine PROCedure Heading (txt$)
5780   LOCal w%,cpl%,t$
5790   IF fulldisplay% = 0 THEN RETurn
5800   t$ = txt$ : IF t$ = '' THEN t$ = 'MAQNIFIER'
5810   w% = FLIM_W(#1)-4-238
5820   cpl% =  w% DIV 12 : REMark in csize 2,0
5830   IF LEN(t$) > cpl% THEN t$ = t$(1 TO cpl%)
5840   MWINDOW #0,1!\0 : CLS #0 : CSIZE #0,2,0 : WM_INK #0,HEX('0210')
5850   CURSOR #0,(w%-12*LEN(t$)) DIV 2,0
5860   PRINT #0,t$; : MWINDOW #0,0 : CSIZE #0,0,0
5870 END DEFine Heading
5880 :
5890 DEFine PROCedure Magnify_Area
5900   LOCal y,x,plotx%,ploty%
5910   MWINDOW #0,1 : COLOUR_NATIVE
5920   :
5930   REMark suppress cursor here momentarily while magnifying if required
5940   :
5950   ploty% = 0 : REMark start point down maqnifier window
5960   dm% = DMODE : REMark need to know which screen mode we are in
5970   SELect ON dm%
5980     =0,4,8 : REMark QL modes cursor magnify
5990       FOR y = oy% TO ey%
6000         plotx% = 0 : REMark start point in maqnifier window
6010         addr = SCR_BASE+(y*SCR_LLEN)+(2*ox%) : REMark start address
6020         FOR x = ox% TO ex%
6030           addr2 = addr+2*(x DIV 8) : REMark identify word holding pixel
6040           BLOCK #0,scale%,scale%,plotx%,ploty%,4*((PEEK(addr2)&&b%(x MOD 8))<>0) + 2*((PEEK(addr2+1)&&b%(x MOD 8))<>0)
6050           plotx% = plotx%+scale% : REMark next point to plot across
6060         END FOR x
6070         ploty% = ploty%+scale%   : REMark next line down
6080         plotx% = 0               : REMark start of next line
6090       END FOR y
6100       :
6110     =16 : REMark mode 16 (Aurora 8-bit colour)
6120       FOR y = oy% TO ey%
6130         plotx% = 0 : REMark start point in maqnifier window
6140         addr = SCR_BASE+(y*SCR_LLEN)+ox% : REMark start address
6150         FOR x = ox% TO ex%
6160           BLOCK #0,scale%,scale%,plotx%,ploty%,PEEK(addr)
6170           plotx% = plotx%+scale% : REMark next plotted pixel across
6180           addr = addr+1          : REMark address of next colour word byte
6190         END FOR x
6200         ploty% = ploty%+scale%   : REMark next line down
6210         plotx% = 0               : REMark start of next line
6220       END FOR y
6230       :
6240     =32 : REMark mode 32 (16-bit QPC/QXL) cursor magnify
6250       REMark MAY need to byte-reverse on platforms as diverse as
6260       REMark MACHINE=30 (QPC-Intel) and MACHINE=28 (QXL-680x0)
6270       FOR y = oy% TO ey%
6280         plotx% = 0 : REMark start point in magnifier window
6290         addr = SCR_BASE+(y*SCR_LLEN)+(2*ox%) : REMark start address
6300         FOR x = ox% TO ex%
6310           BLOCK #0,scale%,scale%,plotx%,ploty%,PEEK(addr)+256*(PEEK(addr+1)) : REMark byte reversed on Intel
6320           plotx% = plotx%+scale% : REMark next plotted pixel across
6330           addr = addr+2          : REMark address of next colour word value
6340         END FOR x
6350         ploty% = ploty%+scale%   : REMark next line down
6360         plotx% = 0               : REMark start of next line
6370       END FOR y
6380       :
6390     =33 : REMark mode 33 Qx0 cursor magnify
6400       FOR y = oy% TO ey%
6410         plotx% = 0 : REMark start point in magnifier window
6420         addr = SCR_BASE+(y*SCR_LLEN)+(2*ox%) : REMark start address
6430         FOR x = ox% TO ex%
6440           BLOCK #0,scale%,scale%,plotx%,ploty%,PEEK_W(addr) : REMark not byte reversed on 680x0
6450           plotx% = plotx%+scale% : REMark next plotted pixel across
6460           addr = addr+2          : REMark address of next colour word value
6470         END FOR x
6480         ploty% = ploty%+scale%   : REMark next line down
6490         plotx% = 0               : REMark start of next line
6500       END FOR y
6510       :
6520   END SELect
6530   :
6540   REMark re-enable cursor in focused program here after magnifying if used
6550   :
6560   COLOUR_QL
6570 END DEFine Magnify_Area
